using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Data;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Controls;
using GrapeCity.ActiveReports.SectionReportModel;
using GrapeCity.ActiveReports.Document.Section;
using GrapeCity.ActiveReports.Document;

namespace ThreadingReports
{
    /// <summary>
    /// Summary description for LongRunningReport.
    /// </summary>
    public partial class LongRunningReport : GrapeCity.ActiveReports.SectionReport
    {

        public LongRunningReport()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

        }

        private void detail_BeforePrint(object sender, EventArgs e)
        {
            if (this.detail.BackColor == Color.Gainsboro)
                this.detail.BackColor = Color.LightSteelBlue;
            else
                this.detail.BackColor = Color.Gainsboro;
        }

        public int GetNoOfRecords(object ds)
        {
            int noOfRecs = 0;

            if (ds.GetType().ToString() == "GrapeCity.ActiveReports.Data.SqlDBDataSource")
            {
                GrapeCity.ActiveReports.Data.SqlDBDataSource ods = (GrapeCity.ActiveReports.Data.SqlDBDataSource)ds;
                SqlConnection con = new SqlConnection(ods.ConnectionString);
                SqlCommand com = new SqlCommand("Select count(*) as totalRecs from (" + ods.SQL + ")", con);
                con.Open();
                SqlDataReader sdr = com.ExecuteReader();
                sdr.Read();
                if (sdr.HasRows)
                {
                    noOfRecs = Convert.ToInt32(sdr[0]);
                }
                con.Close();
            }
            else if (ds.GetType().ToString() == "GrapeCity.ActiveReports.Data.OleDBDataSource")
            {
                GrapeCity.ActiveReports.Data.OleDBDataSource ods = (GrapeCity.ActiveReports.Data.OleDBDataSource)ds;
                OleDbConnection con = new OleDbConnection(ods.ConnectionString);
                OleDbCommand com = new OleDbCommand("Select count(*) as totalRecs from (" + ods.SQL + ")", con);
                con.Open();
                OleDbDataReader odr = com.ExecuteReader();
                odr.Read();
                if (odr.HasRows)
                {
                    noOfRecs = Convert.ToInt32(odr[0]);
                }
                con.Close();
            }
            else if (ds.GetType().ToString() == "GrapeCity.ActiveReports.Data.XMLDataSource")
            {
                GrapeCity.ActiveReports.Data.XMLDataSource xds = (GrapeCity.ActiveReports.Data.XMLDataSource)ds;
                noOfRecs = xds.NodeList.Count;
            }
            else if (ds.GetType().ToString() == "System.Data.DataTable")
            {
                System.Data.DataTable dtds = (System.Data.DataTable)ds;
                noOfRecs = dtds.Rows.Count;
            }
            else
            {
                GrapeCity.ActiveReports.Data.ListDataSource lds = (GrapeCity.ActiveReports.Data.ListDataSource)ds;
                noOfRecs = lds.List.Count;
            }
            return noOfRecs;
        }


    }
}
